# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'reason': 'str',
            'execution_id': 'str',
            'object_id': 'str'
        }

        self.attribute_map = {
            'reason': 'reason',
            'execution_id': 'executionId',
            'object_id': 'objectId'
        }

        self._reason = None
        self._execution_id = None
        self._object_id = None

    @property
    def reason(self) -> str:
        """
        Gets the reason of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        The reason a executionItem encountered an error or warning.

        :return: The reason of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason: str) -> None:
        """
        Sets the reason of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        The reason a executionItem encountered an error or warning.

        :param reason: The reason of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        :type: str
        """
        

        self._reason = reason

    @property
    def execution_id(self) -> str:
        """
        Gets the execution_id of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        If applicable, the executionId for the executionItem that invoked the error or warning.

        :return: The execution_id of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        :rtype: str
        """
        return self._execution_id

    @execution_id.setter
    def execution_id(self, execution_id: str) -> None:
        """
        Sets the execution_id of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        If applicable, the executionId for the executionItem that invoked the error or warning.

        :param execution_id: The execution_id of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        :type: str
        """
        

        self._execution_id = execution_id

    @property
    def object_id(self) -> str:
        """
        Gets the object_id of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        If applicable, the objectId for the executionItem that invoked the error or warning.

        :return: The object_id of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        :rtype: str
        """
        return self._object_id

    @object_id.setter
    def object_id(self, object_id: str) -> None:
        """
        Sets the object_id of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        If applicable, the objectId for the executionItem that invoked the error or warning.

        :param object_id: The object_id of this V2FlowExecutionDataFlowidTopicFlowErrorWarningInfo.
        :type: str
        """
        

        self._object_id = object_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

